jQuery(function ($) {

    let bloks = [];
    bloks.push({
        text: '<div>' + window.mbl_wp.block_0.text + '</div>',
        css: 'position: absolute; padding: 15px; user-select: none; word-break: break-word;',
        type: 'random',
        color: window.mbl_wp.block_0.color,
        opacity: window.mbl_wp.block_0.opacity,
        content: 'dinamic',
        interval: window.mbl_wp.block_0.interval * 1000,
        duration: window.mbl_wp.block_0.duration * 1000,
        animation: window.mbl_wp.block_0.animation * 1000
    });
    bloks.push({
        text: '<div>' + window.mbl_wp.block_1.text + '</div>',
        css: 'position: absolute; top: 0; padding: 15px; user-select: none; word-break: break-word;',
        type: 'top_text',
        color: window.mbl_wp.block_1.color,
        opacity: window.mbl_wp.block_1.opacity,
        content: window.mbl_wp.block_1.content,
        interval: window.mbl_wp.block_1.interval * 1000,
        duration: window.mbl_wp.block_1.duration * 1000,
        animation: window.mbl_wp.block_1.animation * 1000
    });
    bloks.push({
        text: '<div>' + window.mbl_wp.block_2.text + '</div>',
        css: 'display: flex; flex-wrap: wrap; justify-content: space-between; text-align: center; position: absolute; right: 0; padding: 0 25px; top: calc(50% - 25px); left: 0; transform: rotate(-15deg); user-select: none;',
        type: 'center_text',
        color: window.mbl_wp.block_2.color,
        opacity: window.mbl_wp.block_2.opacity,
        content: window.mbl_wp.block_2.content,
        interval: window.mbl_wp.block_2.interval * 1000,
        duration: window.mbl_wp.block_2.duration * 1000,
        animation: window.mbl_wp.block_2.animation * 1000
    });
    bloks.push({
        text: '<div>' + window.mbl_wp.block_3.text + '</div>',
        css: 'position: absolute; right: 0; padding: 15px; bottom: 52px; user-select: none; word-break: break-word;',
        type: 'bottom_text',
        color: window.mbl_wp.block_3.color,
        opacity: window.mbl_wp.block_3.opacity,
        content: window.mbl_wp.block_3.content,
        interval: window.mbl_wp.block_3.interval * 1000,
        duration: window.mbl_wp.block_3.duration * 1000,
        animation: window.mbl_wp.block_3.animation * 1000
    });
    bloks.push({
        text: '<div>' + window.mbl_wp.block_4.text + '</div>',
        css: 'padding: 15px; word-break: break-word;',
        type: 'bottom_text_outside',
        content: 'static',
        opacity: 0,
        color: window.mbl_wp.block_4.color,
        border: window.mbl_wp.block_4.border,
        background: window.mbl_wp.block_4.background,
    });

    function addTexts() {
        $('.plyr .plyr__video-wrapper').map( function(i, el){
            if(window.mbl_wp.display_all == 'on' || $(el).closest('[data-protect=on]').length ) {

                //remove pip
                $(el).closest('.plyr--pip-supported').find('[data-plyr="pip"]').remove();

                bloks.map( function(block) {
                    if ( $(block.text).html() !=  '') {

                        if (block.content == 'static') {
                            block.interval = 10000;
                        }

                        if( block.type == 'bottom_text_outside') {

                            let parent = $(el).closest('.wpm-video-size-wrap');
                            let newBlock = $(block.text).attr('style', block.css);
                            newBlock.css({ opacity: 1, border: '1px solid #' + block.border, color: '#' + block.color, backgroundColor: '#' + block.background })
                            newBlock.appendTo($(parent));

                        } else {

                            renderBlock(el, block);

                            setInterval(() => {
                                renderBlock(el, block)
                            }, block.interval);
                        }
                    }
                });
            }
        })
    }

    function renderBlock(el, block) {

        //return if block disabled
        if(!el.clientHeight) return;

        //cout real video size
        let videoTag = $(el).find('video')[0];
        let height = '100%';
        let width = '100%';
        if ( videoTag ){

            let ratio  = videoTag.videoWidth / videoTag.videoHeight;

            height = '100%';
            width = '100%';

            if ( el.clientHeight * ratio <= el.clientWidth) {
                width = el.clientHeight * ratio + 'px';
            } else {
                height = el.clientWidth / ratio + 'px';
            }

        } else {
            height = el.clientHeight;
            width = el.clientWidth;
        }


        let wrapper = $('<div></div>').css({
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            margin: 'auto',
            height: height,
            width: width,
            paddingBottom: 0,
            transform: 'none'
        });
        wrapper.css(randomStyle());
        el = wrapper.appendTo($(el));

        //for random coordinates
        if( block.type == 'random') {
            let tempBlock = $(block.text).css({visibility: 'hidden', top: 0, left: 0, position: 'absolute'});
            tempBlock.appendTo($(el));
            el.maxLeft = el[0].clientWidth - tempBlock[0].clientWidth;
            el.maxTop = el[0].clientHeight - tempBlock[0].clientHeight;
            tempBlock.remove();
        }

        let newBlock = $(block.text).attr('style', block.css).css({ opacity: 0, color: '#' + block.color });

        if( block.type == 'random') {
            let top = Math.floor(Math.random() * (el.maxTop + 1));
            let left = Math.floor(Math.random() * (el.maxLeft + 1));

            newBlock.css({top: top, left: left});
        }

        newBlock = justifyText(block, newBlock);
        newBlock.css(randomStyle());

        if (block.content == 'dinamic') {

            newBlock.appendTo($(el)).fadeTo(block.animation, (100 - block.opacity) / 100, function () {
                setTimeout(() => {
                    $(this).fadeTo(block.animation, 0, function () {
                        $(this).parent().remove();
                    });
                }, block.duration)
            });

        } else {

            newBlock.css({ opacity: (100 - block.opacity) / 100 });
            newBlock.appendTo($(el));
            setTimeout(() => {
                    $(newBlock).parent().remove();
            }, block.interval)

        }
    }

    function randomStyle() {
        let styles = ['background-position', 'background-size', 'border-radius'];
        let rand = Math.floor(Math.random() * 100);
        let style = styles[Math.floor(Math.random() * 3)];
        return {
            [style]: rand + '%'
        };
    }

    function justifyText(block, newBlock) {

        if (block.type == 'center_text') {

            let text = newBlock.text().split('');

            text = text.map(function(el){
                return '<div>'+el+'</div>'
            });

            newBlock.html(text)
        }

        return newBlock;
    }

    addTexts();



});
