<?php

class MBLWPAdmin
{
    public function __construct()
    {
        $this->_setHooks();
    }

    private function _setHooks()
    {
        $this->_addMKKConfig();
        $this->_addScripts();
    }

    private function _addMKKConfig()
    {
        add_action('mbl_options_items_after', array($this, 'addMBLWPConfigOption'), 70);
        add_action('mbl_options_content_after', array($this, 'addMBLWPConfigContent'), 70);
        
        
        add_action('insert_video_before_settings', array($this, 'addVideoSetting'));
        add_action('insert_video_shortcode_script', array($this, 'upgradeScript'));
    }

    public function addMBLWPConfigOption()
    {
        mblwp_render_partial('protection_option_item', 'admin');
    }

    public function addMBLWPConfigContent($args)
    {
		mblwp_render_partial('protection_options_content', 'admin', $args);
    }

    private function _addScripts()
    {
        add_action('admin_enqueue_scripts', array($this, 'addAdminStyles'));
    }

    public function addAdminStyles()
    {
		wp_enqueue_style('mwp_settins_style', plugins_url('/mbl-protection/assets/css/settings.css'), array(), MBL_WP_VERSION);
    }
    
    public function addVideoSetting()
    {
		?>
		<label for="video-protection">
			<input type="checkbox"
				   id="video-protection"
				   name="protection"
				   value="protection"
			/>
			Защита от камеры
		</label><br><br>
		<?php
    }
    
    public function upgradeScript()
    {
		?>
		if ($('#video-protection').is(':checked')) {
			shortcode += ' protection=on';
		}
		<?php
    }
   
}