<?php

class MBLWPCore
{
    private static $_defaultOptions = array(
        'mbl_wp' => array(
        	'display_all' => 'off',
			'uc_text' => 'К сожалению, этот браузер не поддерживается, воспользуйтесь другим',
			'block_0'    => array(
				'display'      => 'off',
				'opacity'      => 0,
				'color'      => '009f10',
				'data_type'    => 'fio',
				'interval'    => 10,
				'duration'    => 5,
				'animation'    => 1,
			),
			'block_1'    => array(
				'display'      => 'off',
				'opacity'      => 0,
				'color'      => '009f10',
				'data_type'    => 'fio',
				'content'    => 'dinamic',
				'interval'    => 10,
				'duration'    => 5,
				'animation'    => 1,
			),
			'block_2'    => array(
				'display'      => 'off',
				'opacity'      => 0,
				'color'      => '009f10',
				'data_type'    => 'fio',
				'content'    => 'dinamic',
				'interval'    => 10,
				'duration'    => 5,
				'animation'    => 1,
			),
			'block_3'    => array(
				'display'      => 'off',
				'opacity'      => 0,
				'color'      => '009f10',
				'data_type'    => 'fio',
				'content'    => 'dinamic',
				'interval'    => 10,
				'duration'    => 5,
				'animation'    => 1,
			),
			'block_4'    => array(
				'display'      => 'off',
				'text'      => 'Предупреждение об ответственности за мошенничество',
				'color'      => '009f10',
				'border'      => 'ffffff',
				'background'      => 'ffffff',
			)
        ),
    );

    public function __construct()
    {
        if ($this->_pluginEnabled()) {
            $this->_run();
        } elseif (is_admin()) {
            add_action('admin_notices', array($this, 'notActiveNotice'));
        }
    }

    public function notActiveNotice()
    {
        $class = 'notice notice-error';
        $message = __('МОДУЛЬ ЗАЩИТЫ ОТ ЗАПИСИ не активирован!', 'mbl_admin');

        if(!defined('WP_MEMBERSHIP_VERSION')) {
            $message .= ' ' . __('Не установлен плагин MEMBERLUX.', 'mbl_admin');
        } elseif (version_compare(get_option('wpm_version'), '2.2.9.3.9', '<')) {
            $message .= ' ' . __('Устаревшая версия MEMBERLUX.', 'mbl_admin');
        } elseif (!$this->_pluginKeyActive()) {
            $message .= ' ' . __('Ключ не активирован.', 'mbl_admin');
        }

        printf('<div class="%1$s"><p>%2$s</p></div>', esc_attr($class), esc_html($message));
    }

    private function _pluginEnabled()
    {
        return defined('WP_MEMBERSHIP_VERSION')
            && !version_compare(get_option('wpm_version'), '2.2.9.3.9', '<=')
            && $this->_pluginKeyActive();
    }

    private function _pluginKeyActive()
    {
        $activeKeys = wpm_array_pluck(wpm_array_get(wpm_get_key_data(), 'keys.active', array()), 'type');

        if (count(wpm_array_filter($activeKeys, 'fullpackaccess'))) {
            return true;
        }

		return (bool)count(wpm_array_filter($activeKeys, 'protection'));
    }

    private function _run()
    {
        new MBLWPAdmin();
        new MBLWPPublic();
        new MBLWPView();
    }

    public static function install()
    {
        defined('WP_MEMBERSHIP_VERSION') || exit;

        self::_setDefaultOptions();
    }

    private static function _setDefaultOptions()
    {
        foreach (self::$_defaultOptions as $key => $value) {
            self::_setDefaultOption($key, $value);
        }
    }

    private static function _setDefaultOption($key, $value)
    {
        if (is_array($value)) {
            foreach ($value as $_key => $_value) {
                self::_setDefaultOption($key . '.' . $_key, $_value);
            }
        } elseif (wpm_get_option($key) === null) {
			$main_options = get_option('wpm_main_options');

			if(!isset($main_options) || !is_array($main_options)) {
				$main_options = array();
			}

			update_option('wpm_main_options', wpm_array_set($main_options, $key, $value));
        }
    }

    public static function uninstall()
    {

    }
}
